Index: .hgsub
===================================================================
--- .hgsub	(revision 786)
+++ .hgsub	(revision 0)
@@ -1,1 +1,1 @@
-inc/libs/clearbricks = https://clearbricks.org/hg
+inc/libs/clearbricks = https://bitbucket.org/dotclear/clearbricks
Index: .hgsubstate
===================================================================
--- .hgsubstate	(revision 843)
+++ .hgsubstate	(revision 782)
@@ -1,1 +1,1 @@
-4f62679e0756104bdc0b49eacaed9aba68735aa5 inc/libs/clearbricks
+cf8874ccc1fae0e9315d461497ff019f6dafeb7f inc/libs/clearbricks
Index: .hgtags
===================================================================
--- .hgtags	(revision 800)
+++ .hgtags	(revision 369)
@@ -1,7 +1,2 @@
 ec077f3c6b20bc6f7f40a113acaff0220457a2c4 2.3.0
 4e0137ddb12474d62b88c4966d5895a391b6d382 2.3.1
-43a9cace0f39c95463e66346dcc953ced40836be 2.4.2
-43a9cace0f39c95463e66346dcc953ced40836be 2.4.2
-0000000000000000000000000000000000000000 2.4.2
-0000000000000000000000000000000000000000 2.4.2
-6b3942c0cf7eee71ebd906ec0827c5962823dedf 2.4.2
Index: CHANGELOG
===================================================================
--- CHANGELOG	(revision 978)
+++ CHANGELOG	(revision 777)
@@ -1,60 +1,12 @@
-Dotclear 2.5.0 - 201?-??-13
-===========================================================
-* Add (none) option to image insertion title pattern
-* Smileys are not more converted in image in pre,code,kbd,script and math contents
-* Notes' title can be now enclosed in h4 (default), h3 or p HTML tag
-* Now display translated name and desc of plugins
-* Add publication date validation on post and page editing forms
-* Add description to widgets
-* Add syntax color option to theme editor plugin
-* Add delete button on media item page
-* Add/complement display modes (all pages, home page only, except on home page) for all widgets
-* {{tpl:Widgets}} without type attribute set displays now all widgets (from nav, extra and custom)
-* Add {{tpl:else}}, {{tpl:TagCount}}, <tpl:TagIf>, {{tpl:CategoryEntriesCount}} template tags
-* Add cat_only, no_tag and content_only attributes to {{tpl:EntryFirstImage}} tag
-* Add capitalize attribute to template filters' list
-* Enhance links lookup anti spam filter
-* Add hidden optional attribute for pages
-* Adaptative compression rate for thumbnails generation
-* Add timestamp on admin information messages
-* Update to jQuery 1.8.2 and jQuery-UI 1.9 (custom)
-* Add default favicon.ico
-* Add default attributes settings for image,mp3,flv insertion
-* Various bug fixes
-* Various cosmetic updates and contrast adjustments
-
-Dotclear 2.4.4 - 2012-08-13
-===========================================================
-* Bugfix: Programmed entries works again.
-* Compatibility fix: widgets are now fully php >=5.3 compliant
-* Security fix: potential CSRF in user management
-* has_tag now part of dotclear core, moved from tag plugin.
-* empty title fixed on rss reader widget
-
-Dotclear 2.4.3 - 2012-05-18
-===========================================================
-* Admin: My favorites menu can be hidden
-* Admin: Fix wordpress importer
-* Admin: about:config and user:pref tables are now more readable
-* Ductile theme: Blog logo can be changed
-* New lithuanian language (thanks to Paulius Černakauskas)
-* Various bug fixes
-
-Dotclear 2.4.2 - 2012-02-11
-===========================================================
-* Security fix release
-* 4 XSS vulnerabilities fixed, discovered by High-Tech Bridge
-
-Dotclear 2.4.1.2 - 2011-12-24
-===========================================================
-* Happy Christmas!
-* Security: fixed one SQL injection vulnerability in Clearbricks, thanks to Adjaya
-* New behaviour: publicGetURLFor
-* New behaviour: publicRegisterURL
-* New behaviour: templatePrepareParams
+Dotclear 2.4.1-dev
+===========================================================
+* New behavior : publicGetURLFor
+* New behavior : publicRegisterURL
+* New behavior : templatePrepareParams
 * Changed the way to get artefacts URLs, through $core->url->getURLFor calls, instead of $core->url->getBase()
 * new/updated parameter sql_only in $core->blog->getPosts and $core->blog->getComments
 
-Dotclear 2.4.0 - 2011-11-13
+
+Dotclear 2.4.0
 ===========================================================
 * Admin: new iconset from Thomas Daveluy
@@ -69,5 +21,5 @@
 * Various bug fixes
 
-Dotclear 2.3.1 - 2011-06-14
+Dotclear 2.3.1 - 2001-06-14
 ===========================================================
 * Updated makefile for cleaner distrib.
Index: admin/auth.php
===================================================================
--- admin/auth.php	(revision 794)
+++ admin/auth.php	(revision 550)
@@ -31,5 +31,5 @@
 
 $change_pwd = $core->auth->allowPassChange() && isset($_POST['new_pwd']) && isset($_POST['new_pwd_c']) && isset($_POST['login_data']);
-$login_data = !empty($_POST['login_data']) ? html::escapeHTML($_POST['login_data']) : null;
+$login_data = !empty($_POST['login_data']) ? $_POST['login_data'] : null;
 $recover = $core->auth->allowPassChange() && !empty($_REQUEST['recover']);
 $safe_mode = !empty($_REQUEST['safe_mode']);
Index: admin/blog_pref.php
===================================================================
--- admin/blog_pref.php	(revision 976)
+++ admin/blog_pref.php	(revision 557)
@@ -82,7 +82,5 @@
 	__('year/month/title') => '{y}/{m}/{t}',
 	__('year/title') => '{y}/{t}',
-	__('title') => '{t}',
-	__('post id/title') => '{id}/{t}',
-	__('post id') => '{id}'
+	__('title') => '{t}'
 );
 if (!in_array($blog_settings->system->post_url_format,$post_url_combo)) {
@@ -90,14 +88,6 @@
 }
 
-# Note title tag combo
-$note_title_tag_combo = array(
-	__('H4') => 0,
-	__('H3') => 1,
-	__('P') => 2
-);
-
 # Image title combo
 $img_title_combo = array(
-	__('(none)') => '',
 	__('Title') => 'Title ;; separator(, )',
 	__('Title, Date') => 'Title ;; Date(%b %Y) ;; separator(, )',
@@ -108,20 +98,4 @@
 	$img_title_combo[html::escapeHTML($blog_settings->system->media_img_title_pattern)] = html::escapeHTML($blog_settings->system->media_img_title_pattern);
 }
-
-# Image default size combo
-$img_default_size_combo = array();
-$media = new dcMedia($core);
-$img_default_size_combo[__('original')] = 'o';
-foreach ($media->thumb_sizes as $code => $size) {
-	$img_default_size_combo[__($size[2])] = $code;
-}
-
-# Image default alignment combo
-$img_default_alignment_combo = array(
-	__('None') => 'none',
-	__('Left') => 'left',
-	__('Right') => 'right',
-	__('Center') => 'center'
-);
 
 # Robots policy options
@@ -217,5 +191,4 @@
 		$blog_settings->system->put('wiki_comments',!empty($_POST['wiki_comments']));
 		$blog_settings->system->put('enable_xmlrpc',!empty($_POST['enable_xmlrpc']));
-		$blog_settings->system->put('note_title_tag',$_POST['note_title_tag']);
 		
 		$blog_settings->system->put('nb_post_per_page',$nb_post_per_page);
@@ -225,7 +198,4 @@
 		$blog_settings->system->put('media_img_m_size',$media_img_m_size);
 		$blog_settings->system->put('media_img_title_pattern',$_POST['media_img_title_pattern']);
-		$blog_settings->system->put('media_img_default_size',$_POST['media_img_default_size']);
-		$blog_settings->system->put('media_img_default_alignment',$_POST['media_img_default_alignment']);
-		$blog_settings->system->put('media_img_default_link',!empty($_POST['media_img_default_link']));
 		$blog_settings->system->put('nb_post_per_feed',$nb_post_per_feed);
 		$blog_settings->system->put('nb_comment_per_feed',$nb_comment_per_feed);
@@ -277,9 +247,9 @@
 	
 	if (!empty($_GET['add'])) {
-		dcPage::message(__('Blog has been successfully created.'));
+		echo '<p class="message">'.__('Blog has been successfully created.').'</p>';
 	}
 	
 	if (!empty($_GET['upd'])) {
-		dcPage::message(__('Blog has been successfully updated.'));
+		echo '<p class="message">'.__('Blog has been successfully updated.').'</p>';
 	}
 	
@@ -340,41 +310,19 @@
 	form::combo('blog_timezone',dt::getZones(true,true),html::escapeHTML($blog_settings->system->blog_timezone)).
 	'</label></p>'.
-
+	'</div>'.
+	
+	'<div class="col">'.
 	'<p><label for="copyright_notice">'.__('Copyright notice:').
 	form::field('copyright_notice',30,255,html::escapeHTML($blog_settings->system->copyright_notice)).
 	'</label></p>'.
-	'</div>'.
-	
-	'<div class="col">'.
+	
 	'<p><label for="post_url_format">'.__('New post URL format:').
 	form::combo('post_url_format',$post_url_combo,html::escapeHTML($blog_settings->system->post_url_format)).
 	'</label></p>'.
-
-	'<p><label for="note_title_tag">'.__('Note title HTML tag:').
-	form::combo('note_title_tag',$note_title_tag_combo,$blog_settings->system->note_title_tag).
-	'</label></p>'.
-		
+	
 	'<p><label for="enable_xmlrpc" class="classic">'.
 	form::checkbox('enable_xmlrpc','1',$blog_settings->system->enable_xmlrpc).
-	__('Enable XML/RPC interface').'</label></p>';
-
-	echo
-		'<p class="form-note">'.__('XML/RPC interface allows you to edit your blog with an external client.').'</p>';	
-
-	if ($blog_settings->system->enable_xmlrpc) {
-		echo
-		'<p>'.__('XML/RPC interface is active. You should set the following parameters on your XML/RPC client:').'</p>'.
-		'<ul>'.
-		'<li>'.__('Server URL:').' <strong><code>'.
-		sprintf(DC_XMLRPC_URL,$core->blog->url,$core->blog->id).
-		'</code></strong></li>'.
-		'<li>'.__('Blogging system:').' <strong><code>Movable Type</code></strong></li>'.
-		'<li>'.__('User name:').' <strong><code>'.$core->auth->userID().'</code></strong></li>'.
-		'<li>'.__('Password:').' <strong><code>&lt;'.__('your password').'&gt;</code></strong></li>'.
-		'<li>'.__('Blog ID:').' <strong><code>1</code></strong></li>'.
-		'</ul>';
-	}
-
-	echo
+	__('Enable XML/RPC interface').'</label>'.
+	' - <a href="#xmlrpc">'.__('more information').'</a></p>'.
 	'</div>'.
 	'</div>'.
@@ -483,20 +431,5 @@
 	'<p>'.form::combo('media_img_title_pattern',$img_title_combo,html::escapeHTML($blog_settings->system->media_img_title_pattern)).'</p>'.
 	'</div>'.
-
-	'<div class="col">'.
-	'<h4>'.__('Default image insertion attributes').'</h4>'.
-	'<p><label for="media_img_default_size">'.__('Image size:').
-	form::combo('media_img_default_size',$img_default_size_combo,
-		(html::escapeHTML($blog_settings->system->media_img_default_size) != '' ? html::escapeHTML($blog_settings->system->media_img_default_size) : 'm')).
-	'</label></p>'.
-	'<p><label for="media_img_default_alignment">'.__('Image alignment').
-	form::combo('media_img_default_alignment',$img_default_alignment_combo,html::escapeHTML($blog_settings->system->media_img_default_alignment)).
-	'</label></p>'.
-	'<p><label for="media_img_default_link" class="classic">'.
-	form::checkbox('media_img_default_link','1',$blog_settings->system->media_img_default_link).
-	__('As a link to original image').'</label></p>'.
-	'</div>'.
-	'</div>'.
-
+	'</div>'.
 	'</fieldset>';
 	
@@ -532,10 +465,28 @@
 		$core->formNonce().'</p>'.
 		'</form>';
-	} else {
-		if ($blog_id == $core->blog->id) {
-			echo '<p class="message">'.__('The current blog cannot be deleted').'</p>';
-		} else {
-			echo '<p class="message">'.__('Only superadmin can delete a blog').'</p>';
-		}
+	}
+	
+	# XML/RPC information
+	echo '<h3 id="xmlrpc">'.__('XML/RPC interface').'</h3>';
+	
+	echo '<p>'.__('XML/RPC interface allows you to edit your blog with an external client.').'</p>';
+	
+	if (!$blog_settings->system->enable_xmlrpc)
+	{
+		echo '<p>'.__('XML/RPC interface is not active. Change settings to enable it.').'</p>';
+	}
+	else
+	{
+		echo
+		'<p>'.__('XML/RPC interface is active. You should set the following parameters on your XML/RPC client:').'</p>'.
+		'<ul>'.
+		'<li>'.__('Server URL:').' <strong>'.
+		sprintf(DC_XMLRPC_URL,$core->blog->url,$core->blog->id).
+		'</strong></li>'.
+		'<li>'.__('Blogging system:').' <strong>Movable Type</strong></li>'.
+		'<li>'.__('User name:').' <strong>'.$core->auth->userID().'</strong></li>'.
+		'<li>'.__('Password:').' <strong>'.__('your password').'</strong></li>'.
+		'<li>'.__('Blog ID:').' <strong>1</strong></li>'.
+		'</ul>';
 	}
 	
@@ -572,5 +523,13 @@
 				' ('.html::escapeHTML(dcUtils::getUserCN(
 					$k, $v['name'], $v['firstname'], $v['displayname']
-				)).')</h4>';
+				)).')';
+				
+				if (!$v['super'] && $core->auth->isSuperAdmin()) {
+					echo
+					' - <a href="permissions.php?blog_id[]='.$blog_id.'&amp;user_id[]='.$k.'">'
+					.__('Change permissions').'</a>';
+				}
+				
+				echo '</h4>';
 				
 				echo '<ul>';
@@ -583,17 +542,4 @@
 				}
 				echo '</ul>';
-				
-				if (!$v['super'] && $core->auth->isSuperAdmin()) {
-					echo 
-					'<form action="users_actions.php" method="post">'.
-					'<p><input type="submit" value="'.__('Change permissions').'" />'.
-					form::hidden(array('redir'),'blog_pref.php?id='.$k).
-					form::hidden(array('action'),'perms').
-					form::hidden(array('users[]'),$k).
-					form::hidden(array('blogs[]'),$blog_id).
-					$core->formNonce().
-					'</p>'.
-					'</form>';
-				}
 			}
 		}
Index: admin/blog_theme.php
===================================================================
--- admin/blog_theme.php	(revision 907)
+++ admin/blog_theme.php	(revision 719)
@@ -219,13 +219,15 @@
 	
 	if (!empty($_GET['upd'])) {
-		dcPage::message(__('Theme has been successfully changed.'));
+		echo '<p class="message">'.__('Theme has been successfully changed.').'</p>';
 	}
 	
 	if (!empty($_GET['added'])) {
-		dcPage::message(($_GET['added'] == 2 ? __('Theme has been successfully upgraded') : __('Theme has been successfully installed.')));
+		echo '<p class="message">'.
+		($_GET['added'] == 2 ? __('Theme has been successfully upgraded') : __('Theme has been successfully installed.')).
+		'</p>';
 	}
 	
 	if (!empty($_GET['del'])) {
-		dcPage::message(__('Theme has been successfully deleted.'));
+		echo '<p class="message">'.__('Theme has been successfully deleted.').'</p>';
 	}
 	
Index: admin/blogs.php
===================================================================
--- admin/blogs.php	(revision 907)
+++ admin/blogs.php	(revision 782)
@@ -15,26 +15,12 @@
 dcPage::check('usage,contentadmin');
 
-# Filters
-$sortby_combo = array(
-__('Last update') => 'blog_upddt',
-__('Blog name') => 'UPPER(blog_name)',
-__('Blog ID') => 'B.blog_id'
-);
+$q = !empty($_GET['q']) ? $_GET['q'] : '';
 
-$order_combo = array(
-__('Descending') => 'desc',
-__('Ascending') => 'asc'
-);
+$blogs_list = new adminBlogList($core);
 
-$q = !empty($_GET['q']) ? $_GET['q'] : '';
-$sortby = !empty($_GET['sortby']) ? $_GET['sortby'] : 'blog_upddt';
-$order = !empty($_GET['order']) ? $_GET['order'] : 'desc';
+$params = new ArrayObject();
 
-$page = !empty($_GET['page']) ? $_GET['page'] : 1;
-$nb_per_page =  30;
-
-if (!empty($_GET['nb']) && (integer) $_GET['nb'] > 0) {
-	$nb_per_page = (integer) $_GET['nb'];
-}
+# - Limit, sortby and order filter
+$params = $blogs_list->applyFilters($params);
 
 $show_filters = false;
@@ -46,21 +32,8 @@
 }
 
-# - Sortby and order filter
-if ($sortby !== '' && in_array($sortby,$sortby_combo)) {
-	if ($order !== '' && in_array($order,$order_combo)) {
-		$params['order'] = $sortby.' '.$order;
-	}
-	
-	if ($sortby != 'blog_upddt' || $order != 'desc') {
-		$show_filters = true;
-	}
-}
-
-$params['limit'] = array((($page-1)*$nb_per_page),$nb_per_page);
-
 try {
 	$counter = $core->getBlogs($params,1);
 	$rs = $core->getBlogs($params);
-	$nb_blog = $counter->f(0);
+	$blogs_list->setItems($rs,$counter->f(0));
 } catch (Exception $e) {
 	$core->error->add($e->getMessage());
@@ -76,5 +49,5 @@
 
 if (!empty($_GET['del'])) {
-	dcPage::message(__('Blog has been successfully deleted.'));
+	echo '<p class="message">'.__('Blog has been successfully deleted.').'</p>';
 }
 
@@ -93,23 +66,10 @@
 	echo
 	'<form action="blogs.php" method="get" id="filters-form">'.
-	'<fieldset class="two-cols"><legend>'.__('Filters').'</legend>'.
+	'<fieldset><legend>'.__('Filters').'</legend>'.
 	
-	'<div class="col">'.
-	'<p><label for="sortby">'.__('Order by:').' '.
-	form::combo('sortby',$sortby_combo,html::escapeHTML($sortby)).
-	'</label> '.
-	'<label for="order">'.__('Sort:').' '.
-	form::combo('order',$order_combo,html::escapeHTML($order)).
-	'</label></p>'.
-	'</div>'.
-	
-	'<div class="col">'.
 	'<p><label for="q">'.__('Search:').' '.
 	form::field('q',20,255,html::escapeHTML($q)).
 	'</label></p>'.
-	'<p><label for="nb" class="classic">'.	form::field('nb',3,3,$nb_per_page).' '.
-	__('Blogs per page').'</label> '.
-	'<input type="submit" value="'.__('Apply filters').'" /></p>'.
-	'</div>'.
+	'<p><input type="submit" value="'.__('Apply filters').'" /></p>'.
 	
 	'<br class="clear" />'. //Opera sucks
@@ -118,68 +78,8 @@
 	
 	# Show blogs
-	if ($nb_blog == 0)
-	{
-		echo '<p><strong>'.__('No blog').'</strong></p>';
-	}
-	else
-	{
-		$pager = new pager($page,$nb_blog,$nb_per_page,10);
-		$pager->var_page = 'page';
-		
-		echo '<p>'.__('Page(s)').' : '.$pager->getLinks().'</p>';
-		
-		echo
-		'<table class="clear"><tr>'.
-		'<th>'.__('Blog name').'</th>'.
-		'<th class="nowrap">'.__('Last update').'</th>'.
-		'<th class="nowrap">'.__('Entries (all types)').'</th>'.
-		'<th class="nowrap">'.__('Blog ID').'</th>'.
-		'<th>&nbsp;</th>'.
-		'<th class="nowrap">'.__('Status').'</th>'.
-		'</tr>';
-		
-		while ($rs->fetch()) {
-			echo blogLine($rs);
-		}
-		
-		echo '</table>';
-		
-		echo '<p>'.__('Page(s)').' : '.$pager->getLinks().'</p>';
-	}
+	$blogs_list->display();
 }
 
 dcPage::close();
 
-function blogLine($rs)
-{
-	global $core;
-	
-	$blog_id = html::escapeHTML($rs->blog_id);
-	$edit_link = '';
-	
-	if ($GLOBALS['core']->auth->isSuperAdmin()) {
-		$edit_link = 
-		'<a href="blog.php?id='.$blog_id.'" '.
-		'title="'.sprintf(__('Edit blog %s'),$blog_id).'">'.
-		__('edit').'</a>';
-	}
-	
-	$img_status = $rs->blog_status == 1 ? 'check-on' : 'check-off';
-	$txt_status = $GLOBALS['core']->getBlogStatus($rs->blog_status);
-	$img_status = sprintf('<img src="images/%1$s.png" alt="%2$s" title="%2$s" />',$img_status,$txt_status);
-	$offset = dt::getTimeOffset($core->auth->getInfo('user_tz'));
-	$blog_upddt = dt::str(__('%Y-%m-%d %H:%M'),strtotime($rs->blog_upddt) + $offset);
-	
-	return
-	'<tr class="line">'.
-	'<td class="maximal"><a href="index.php?switchblog='.$rs->blog_id.'" '.
-	'title="'.sprintf(__('Switch to blog %s'),$rs->blog_id).'">'.
-	html::escapeHTML($rs->blog_name).'</a></td>'.
-	'<td class="nowrap">'.$blog_upddt.'</td>'.
-	'<td class="nowrap">'.$core->countBlogPosts($rs->blog_id).'</td>'.
-	'<td class="nowrap">'.$blog_id.'</td>'.
-	'<td>'.$edit_link.'</td>'.
-	'<td class="status">'.$img_status.'</td>'.
-	'</tr>';
-}
 ?>
Index: admin/categories.php
===================================================================
--- admin/categories.php	(revision 907)
+++ admin/categories.php	(revision 560)
@@ -56,14 +56,14 @@
 
 if (!empty($_GET['add'])) {
-	dcPage::message(__('The category has been successfully created.'));
+	echo '<p class="message">'.__('The category has been successfully created.').'</p>';
 }
 if (!empty($_GET['del'])) {
-	dcPage::message(__('The category has been successfully removed.'));
+		echo '<p class="message">'.__('The category has been successfully removed.').'</p>';
 }
 if (!empty($_GET['reord'])) {
-	dcPage::message(__('Categories have been successfully reordered.'));
+		echo '<p class="message">'.__('Categories have been successfully reordered.').'</p>';
 }
 if (!empty($_GET['moved'])) {
-	dcPage::message(__('The category has been successfully moved.'));
+		echo '<p class="message">'.__('The category has been successfully moved.').'</p>';
 }
 
Index: admin/category.php
===================================================================
--- admin/category.php	(revision 907)
+++ admin/category.php	(revision 500)
@@ -164,5 +164,5 @@
 
 if (!empty($_GET['upd'])) {
-	dcPage::message(__('Category has been successfully updated.'));
+	echo '<p class="message">'.__('Category has been successfully updated.').'</p>';
 }
 
Index: admin/comment.php
===================================================================
--- admin/comment.php	(revision 907)
+++ admin/comment.php	(revision 500)
@@ -171,5 +171,5 @@
 {
 	if (!empty($_GET['upd'])) {
-		dcPage::message(__('Comment has been successfully updated.'));
+		echo '<p class="message">'.__('Comment has been successfully updated.').'</p>';
 	}
 	
Index: admin/comments.php
===================================================================
--- admin/comments.php	(revision 796)
+++ admin/comments.php	(revision 783)
@@ -15,9 +15,21 @@
 dcPage::check('usage,contentadmin');
 
+class authorFilter extends textFilter {
+	public function header() {
+		return 
+			dcPage::jqueryUI().
+			dcPage::jsLoad('js/author_filter.js')
+			;
+	}
+	public function applyFilter($params) {
+		$val = preg_split('/\s*,\s*/',$this->values[0]);
+		$params[$this->request_param]=$val;
+	}
+}
+
+
 # Creating filter combo boxes
 # Filter form we'll put in html_block
-$status_combo = array(
-'-' => ''
-);
+$status_combo = array();
 foreach ($core->blog->getAllCommentStatus() as $k => $v) {
 	$status_combo[$v] = (string) $k;
@@ -25,100 +37,17 @@
 
 $type_combo = array(
-'-' => '',
-__('comment') => 'co',
-__('trackback') => 'tb'
+__('comment') => '0',
+__('trackback') => '1'
 );
 
-$sortby_combo = array(
-__('Date') => 'comment_dt',
-__('Entry title') => 'post_title',
-__('Author') => 'comment_author',
-__('Status') => 'comment_status'
-);
+$comment_list = new adminCommentList($core);
 
-$order_combo = array(
-__('Descending') => 'desc',
-__('Ascending') => 'asc'
-);
-
-
-/* Get comments
--------------------------------------------------------- */
-$author = isset($_GET['author']) ?	$_GET['author'] : '';
-$status = isset($_GET['status']) ?		$_GET['status'] : '';
-$type = !empty($_GET['type']) ?		$_GET['type'] : '';
-$sortby = !empty($_GET['sortby']) ?	$_GET['sortby'] : 'comment_dt';
-$order = !empty($_GET['order']) ?		$_GET['order'] : 'desc';
-$ip = !empty($_GET['ip']) ?			$_GET['ip'] : '';
-
-$with_spam = $author || $status || $type || $sortby != 'comment_dt' || $order != 'desc' || $ip;
-
-$show_filters = false;
-
-$page = !empty($_GET['page']) ? (integer) $_GET['page'] : 1;
-$nb_per_page =  30;
-
-if (!empty($_GET['nb']) && (integer) $_GET['nb'] > 0) {
-	if ($nb_per_page != $_GET['nb']) {
-		$show_filters = true;
-	}
-	$nb_per_page = (integer) $_GET['nb'];
-}
-
-$params['limit'] = array((($page-1)*$nb_per_page),$nb_per_page);
+$params = new ArrayObject();
 $params['no_content'] = true;
 
-# Author filter
-if ($author !== '') {
-	$params['q_author'] = $author;
-	$show_filters = true;
-} else {
-	$author='';
-}
-
-# - Type filter
-if ($type == 'tb' || $type == 'co') {
-	$params['comment_trackback'] = ($type == 'tb');
-	$show_filters = true;
-} else {
-	$type='';
-}
-
-# - Status filter
-if ($status !== '' && in_array($status,$status_combo)) {
-	$params['comment_status'] = $status;
-	$show_filters = true;
-} elseif (!$with_spam) {
-	$params['comment_status_not'] = -2;
-	$status='';
-} else {
-	$status='';
-}
-
-# - IP filter
-if ($ip) {
-	$params['comment_ip'] = $ip;
-	$show_filters = true;
-}
-
-# Sortby and order filter
-if ($sortby !== '' && in_array($sortby,$sortby_combo)) {
-	if ($order !== '' && in_array($order,$order_combo)) {
-		$params['order'] = $sortby.' '.$order;
-	} else {
-		$order = 'desc';
-	}
-	
-	if ($sortby != 'comment_dt' || $order != 'desc') {
-		$show_filters = true;
-	}
-} else {
-	$sortby = 'comment_dt';
-	$order = 'desc';
-}
+# - Limit, sortby and order filter
 
 # Actions combo box
 $combo_action = array();
-$default = '';
 if ($core->auth->check('publish,contentadmin',$core->blog->id))
 {
@@ -130,8 +59,5 @@
 if ($core->auth->check('delete,contentadmin',$core->blog->id))
 {
-	$combo_action[__('Delete')] = 'delete';
-	if ($status == -2) {
-		$default = 'delete';
-	}
+	$combo_action[__('delete')] = 'delete';
 }
 
@@ -139,10 +65,42 @@
 $core->callBehavior('adminCommentsActionsCombo',array(&$combo_action));
 
+$filterSet = new dcFilterSet('comments','comments.php');
+
+$authorFilter = new authorFilter(
+		'author',__('Author'), __('Author'),'comment_author',20,255);
+$filterSet
+	->addFilter(new comboFilter(
+		'status',__('Status'), __('Status'), 'comment_status', $status_combo))
+	->addFilter(new booleanFilter(
+		'type',__('Type'), __('Type'), 'comment_trackback', $type_combo))
+	->addFilter($authorFilter)
+	->addFilter(new textFilter(
+		'ip',__('IP address'), __('IP address'), 'comment_ip',20,39));
+		
+$core->callBehavior('adminCommentsFilters',$filterSet);
+$filterSet->setExtra($comment_list);
+
+$filterSet->setup($_GET,$_POST);
+if (isset($_GET['author'])) {
+	$authorFilter->add();
+	$authorFilter->setValues($_GET['author']);
+}
+$with_spam=true;
 /* Get comments
 -------------------------------------------------------- */
 try {
+	$nfparams = $params->getArrayCopy();
+	$filtered = $filterSet->applyFilters($params);
+	$core->callBehavior('adminCommentsParams',$params);
 	$comments = $core->blog->getComments($params);
 	$counter = $core->blog->getComments($params,true);
-	$comment_list = new adminCommentList($core,$comments,$counter->f(0));
+	if ($filtered) {
+		$totalcounter = $core->blog->getComments($nfparams,true);
+		$page_title = sprintf(__('Comments and Trackacks / %s filtered out of %s'),$counter->f(0),$totalcounter->f(0));
+	} else {
+		$page_title = __('Comments and Trackacks');
+	}
+
+	$comment_list->setItems($comments,$counter->f(0));
 } catch (Exception $e) {
 	$core->error->add($e->getMessage());
@@ -151,8 +109,6 @@
 /* DISPLAY
 -------------------------------------------------------- */
-$starting_script = dcPage::jsLoad('js/_comments.js');
-if (!$show_filters) {
-	$starting_script .= dcPage::jsLoad('js/filter-controls.js');
-}
+$starting_script = dcPage::jsLoad('js/_comments.js').$filterSet->header();
+
 # --BEHAVIOR-- adminCommentsHeaders
 $starting_script .= $core->callBehavior('adminCommentsHeaders');
@@ -165,47 +121,5 @@
 {
 	# Filters
-	if (!$show_filters) {
-		echo '<p><a id="filter-control" class="form-control" href="#">'.
-		__('Filters').'</a></p>';
-	}
-	
-	echo
-	'<form action="comments.php" method="get" id="filters-form">'.
-	'<fieldset><legend>'.__('Filters').'</legend>'.
-	'<div class="three-cols">'.
-	'<div class="col">'.
-	'<label for="type">'.__('Type:').' '.
-	form::combo('type',$type_combo,$type).
-	'</label> '.
-	'<label for="status">'.__('Status:').' '.
-	form::combo('status',$status_combo,$status).
-	'</label>'.
-	'</div>'.
-	
-	'<div class="col">'.
-	'<p><label for="sortby">'.__('Order by:').' '.
-	form::combo('sortby',$sortby_combo,$sortby).
-	'</label> '.
-	'<label for="order">'.__('Sort:').' '.
-	form::combo('order',$order_combo,$order).
-	'</label></p>'.
-	'<p><label for="nb" class="classic">'.	form::field('nb',3,3,$nb_per_page).' '.
-	__('Comments per page').'</label></p>'.
-	'</div>'.
-	
-	'<div class="col">'.
-	'<p><label for="author">'.__('Comment author:').' '.
-	form::field('author',20,255,html::escapeHTML($author)).
-	'</label>'.
-	'<label for="ip">'.__('IP address:').' '.
-	form::field('ip',20,39,html::escapeHTML($ip)).
-	'</label></p>'.
-	'<p><input type="submit" value="'.__('Apply filters').'" /></p>'.
-	'</div>'.
-	
-	'</div>'.
-	'<br class="clear" />'. //Opera sucks
-	'</fieldset>'.
-	'</form>';
+	$filterSet->display();
 	
 	if (!$with_spam) {
@@ -221,6 +135,5 @@
 	
 	# Show comments
-	$comment_list->display($page,$nb_per_page,
-	'<form action="comments_actions.php" method="post" id="form-comments">'.
+	$comment_list->display('<form action="comments_actions.php" method="post" id="form-comments">'.
 	
 	'%s'.
@@ -230,15 +143,8 @@
 	
 	'<p class="col right"><label for="action" class="classic">'.__('Selected comments action:').'</label> '.
-	form::combo('action',$combo_action,$default,'','','','title="'.__('action: ').'"').
+	form::combo('action',$combo_action,'','','','','title="'.__('action: ').'"').
 	$core->formNonce().
 	'<input type="submit" value="'.__('ok').'" /></p>'.
-	form::hidden(array('type'),$type).
-	form::hidden(array('sortby'),$sortby).
-	form::hidden(array('order'),$order).
-	form::hidden(array('author'),preg_replace('/%/','%%',$author)).
-	form::hidden(array('status'),$status).
-	form::hidden(array('ip'),preg_replace('/%/','%%',$ip)).
-	form::hidden(array('page'),$page).
-	form::hidden(array('nb'),$nb_per_page).
+	str_replace('%','%%',$filterSet->getFormFieldsAsHidden()).
 	'</div>'.
 	
Index: admin/comments_actions.php
===================================================================
--- admin/comments_actions.php	(revision 270)
+++ admin/comments_actions.php	(revision 782)
@@ -30,12 +30,5 @@
 	{
 		$redir =
-		'comments.php?type='.$_POST['type'].
-		'&author='.$_POST['author'].
-		'&status='.$_POST['status'].
-		'&sortby='.$_POST['sortby'].
-		'&ip='.$_POST['ip'].
-		'&order='.$_POST['order'].
-		'&page='.$_POST['page'].
-		'&nb='.(integer) $_POST['nb'];
+		'comments.php?'.urldecode($_POST['f_query']);
 	}
 	
Index: admin/dispatcher.php
===================================================================
--- admin/dispatcher.php	(revision 270)
+++ admin/dispatcher.php	(revision 270)
@@ -0,0 +1,34 @@
+<?php
+# -- BEGIN LICENSE BLOCK ---------------------------------------
+#
+# This file is part of Dotclear 2.
+#
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
+# Licensed under the GPL version 2.0 license.
+# See LICENSE file or
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+#
+# -- END LICENSE BLOCK -----------------------------------------
+
+# Delete users
+if (!empty($_REQUEST['dispatch_action']))
+{
+	if ($_REQUEST['dispatch_action'] == 'deleteuser')
+	{
+		if (!empty($_REQUEST['user_id'])) {
+			$delete_users = $_REQUEST['user_id'];
+		}
+		
+		include dirname(__FILE__).'/users.php';
+		exit;
+	}
+	elseif ($_REQUEST['dispatch_action'] == 'setpermissions')
+	{
+		include dirname(__FILE__).'/permissions_blog.php';
+		exit;
+	}
+}
+
+echo '<p>What the hell are you doing here?</p>';
+exit;
+?>
